// pages/myloan/myloan.js
import { get,post } from "../../common/request.js"
import pathmap from "../../common/pathmap"
import stylemap from "../../common/stylemap"
import share from "../../common/share"
const app = getApp();

Page(Object.assign({

  /**
   * 页面的初始数据
   */
  data: {
    
    timetorate:{
      "12":"rates_a",
      "24":"rates_b",
      "36":"rates_c"
    },
    price:50,
    time:12,
    scale:0,
    firstpay:0,
    scalename:"零",
    number:["零","一","二","三","四","五","六","七","八","九"]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData(stylemap);
    this.getRate();
    this.getWheres();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
  
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
  
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
  
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
  
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
  
  },
  getWheres:function(){
    var _self = this;
    var wheres = wx.getStorageSync("wheres");
    if(wheres){
      _self.setData({
        wheres: wheres
      })
    }else{
      get(pathmap.wheres, {
        no_brand_series:1
      }, function (json) {
        _self.setData({
          wheres: json.data
        })
        wx.setStorageSync("wheres",json.data);
      })
    }
  },
  getRate:function(){
    var _self=this;
    var mobile = wx.getStorageSync("mobile");
    get(pathmap.rates,{
      mobile:mobile
    },function(json){
      _self.setData(json.data);
    })
  },
  getPrice:function(e){
    var price = e.detail.value;
    this.setData({price:price});
    this.getResult();
  },
  getFirstPay:function(e){    
    var scale = e.detail.value;
    this.setData({scale:scale});
    this.getResult();
  },
  getTime:function(e){
    var time = e.detail.value;
    this.setData({time:time});
    this.getResult();
  },
  getResult:function(){
    var price = this.data.price*10000;
    var scale = this.data.scale;
    var scales = (""+scale/10).split(".");
    var scalename =this.data.number[scales[0]];
    if(scales[1]){
      scalename+=this.data.number[scales[1]]
    }

    var time = this.data.time;
    var interestrate = this.data[this.data.timetorate[time]]/100;
    var firstpay = price*scale/100;
    var premonthpay = (price-firstpay)*interestrate*(Math.pow((1+interestrate),time))/(Math.pow((1+interestrate),time)-1);
    this.setData({
      firstpay:firstpay,
      premonthpay:Math.round(premonthpay),
      scalename:scalename
    })
  },
  toBuy:function(){
    var list = this.data.wheres.price.map(function(item){
      var price = item.price_name.split("-");
      var pricelist = price.map(function(item2){
        return parseInt(item2);
      })
      return {
        price_id:item.price_id,
        pricelist:pricelist
      }
    })
    var price = this.data.price;
    var price_id = 0;
    list.forEach(function(item){
      if(item.pricelist[0]<price&&price<=item.pricelist[1]){
        price_id=item.price_id;
      }
    })
    if(price_id){
      wx.redirectTo({url:"../buy/buy?price="+price_id});
    }else{
      wx.redirectTo({url:"../buy/buy"});
    }
  }
},share))